#!/bin/bash
declare Version=1.1.7
declare Password="F@stSCM!"

echo "Running ${0##*/} v$Version."

# Installing Helix Swarm and Git Fusion packages.
sudo yum install perforce-git-fusion -y
sudo yum install perforce-swarm -y
sudo yum install perforce-cli -y

# Call 'useradd perforce' before installing any Perforce package so we get
# the perforce user home directory where we want it.
sudo useradd -c "Perforce Admin" perforce

sudo yum install perforce-server -y

echo "Allowing user 'perforce' sudo privileges."
echo 'perforce ALL=(ALL:ALL) NOPASSWD: ALL' > /tmp/perforce
sudo chmod 0440 /tmp/perforce
sudo chown root:root /tmp/perforce
sudo mv /tmp/perforce /etc/sudoers.d/.

echo "Creating initial SDP dirs."
declare DirList="/p4 /hxdepots/reset /hxdepots/p4/common/bin/cbd /hxmetadata1 /hxlogs"

mkdirCmd="sudo /bin/mkdir -p $DirList"
echo "Running: $mkdirCmd"
$mkdirCmd

chownCmd="sudo chown -R perforce:perforce $DirList"
echo "Running: $chownCmd"
$chownCmd

echo "Setting up environment niceties for perforce user."
BASH_PROFILE=/tmp/.bash_profile.perforce
echo '[[ -f /etc/bashrc ]] && source /etc/bashrc' > $BASH_PROFILE
echo '[[ -f ~/.bashrc ]] && source ~/.bashrc' >> $BASH_PROFILE
sudo chown perforce:perforce $BASH_PROFILE
sudo mv -f $BASH_PROFILE ~perforce/.bash_profile

BASHRC=/tmp/.bashrc.perforce
echo '[[ -f /p4/common/bin/p4_vars ]] && source /p4/common/bin/p4_vars 1'> $BASHRC
echo "export PS1='\$USER@\${HOSTNAME%%.*}:\$PWD '" >> $BASHRC
echo "alias md='/bin/mkdir -p'" >> $BASHRC
echo "alias rd=/bin/rmdir" >> $BASHRC
echo "alias o='p4 opened ...'" >> $BASHRC
echo "alias go='cd /p4/common/bin/cbd/test && source manual_test_env.sh'" >> $BASHRC
echo 'set -o vi' >> $BASHRC
sudo chown perforce:perforce $BASHRC
sudo mv -f $BASHRC ~perforce/.bashrc

echo "Setting password for perforce user to: $Password"
echo "perforce:$Password" | sudo chpasswd

echo "Setting up environment niceties for vagrant user."
echo "alias go='sudo su - perforce'" >> ~/.bashrc
echo 'set -o vi' >> ~/.bashrc

exit 0
